<?php

/**
 * WP_Meteor
 *
 * @package   WP_Meteor
 * @author    Aleksandr Guidrevitch <alex@excitingstartup.com>
 * @copyright 2020 wp-meteor.com
 * @license   GPL 2.0+
 * @link      https://wp-meteor.com
 */

namespace WP_Meteor\Frontend;

use WP_Meteor\Engine\Base;

/**
 * Enqueue stuff on the frontend
 */
class Rewrite extends Base
{

    public $priority = -3; // based on Autoptimize 
    /**
     * Initialize the class.
     *
     * @return void
     */
    public function initialize()
    {
        if (!preg_match('/wpmeteordisable/', $_SERVER['QUERY_STRING']) && (!\is_admin() && (!defined('DOING_AJAX') || !DOING_AJAX))) {
            if (defined('LSCWP_V') && version_compare(constant('LSCWP_V'), '3.2.3.1 ', '>=')) {
                \add_action('litespeed_buffer_after', array($this, 'rewrite'), PHP_INT_MAX);
            } else {
                \add_action('init', array($this, 'buffer_start'), $this->priority);
            }
        }
    }

    public function buffer_start()
    {
        ob_start(array($this, "rewrite"));
    }

    public function rewrite($buffer)
    {
        $buffer = \apply_filters(WPMETEOR_TEXTDOMAIN . '-frontend-rewrite', $buffer, \wpmeteor_get_settings());
        return preg_replace('/<\/html>/i', "</html>\n<!-- Optimized with WP Meteor https://pagespeedoptimizer.io -->", $buffer);
    }
}
