/**
 *   WP Meteor Wordpress Plugin
 *   Copyright (C) 2020  Aleksandr Guidrevitch
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

import React from 'react';
import Switch from 'react-switch';
export default class Simple extends React.Component {
    constructor(props) {
        super(props)
        this.state = { ...props.settings };
    }
    onEnabledChange = (checked) => {
        this.setState({
            enabled: checked
        });
    }
    render() {
        return (
            <ul>
                <li>
                    <span className="enabled">
                        <Switch
                            id={this.props.prefix + "-id"}
                            name={this.props.prefix + '[enabled]'}
                            checkedIcon={false}
                            uncheckedIcon={false}
                            offColor='#FEA502'
                            onColor='#08CE69'
                            height={16}
                            handleDiameter={20}
                            className="switch"
                            boxShadow='0 0 2px 3px #3bf'
                            checked={!!this.state.enabled}
                            onChange={this.onEnabledChange}
                             />
                        <label htmlFor={this.props.prefix + "-id"}>
                            {this.state.enabled 
                            ? '2 seconds delay'
                            : '1 second delay' }
                        </label>
                    </span>
                </li>
            </ul>
        );
    }
}
