/**
 *   WP Meteor Wordpress Plugin
 *   Copyright (C) 2020  Aleksandr Guidrevitch
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

import dispatcher from '../utils/dispatcher';

/**
 * class name should not match mocked object
 */
export default class jQueryMock {
    constructor() {

        let Mock = window.jQuery;

        Object.defineProperties(window, {
            'jQuery': {
                get() {
                    return Mock;
                },
                set(jQuery) {
                    if (jQuery) {
                        const queue = [];

                        const backupReady = jQuery.fn.ready;
                        // can't use () => {} as it binds to different this
                        jQuery.fn.ready = function (func) {
                            queue.push(func);
                            return this;
                        };
                        dispatcher.on('l', () => {
                            let func;
                            while (func = queue.shift()) {
                                try {
                                    func.call(Mock);
                                } catch (e) {
                                    console.error(e);
                                }
                            }
                            jQuery.fn.ready = backupReady;
                        });
                    }
                    return Mock = jQuery;
                }
            }
        })

    }
}
